Index: /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c	(revision 4460)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c	(revision 4461)
@@ -1659,5 +219,5 @@
 	/* Cancel duration timer, if any */
 	if (app_config.call_data[call_id].timer.id != PJSUA_INVALID_ID) {
-	    struct call_data *cd = &app_config.call_data[call_id];
+	    app_call_data *cd = &app_config.call_data[call_id];
 	    pjsip_endpoint *endpt = pjsua_get_pjsip_endpt();
 
@@ -1696,5 +256,5 @@
 	{
 	    /* Schedule timer to hangup call after the specified duration */
-	    struct call_data *cd = &app_config.call_data[call_id];
+	    app_call_data *cd = &app_config.call_data[call_id];
 	    pjsip_endpoint *endpt = pjsua_get_pjsip_endpt();
 	    pj_time_val delay;
@@ -1810,5 +370,4 @@
     }
 }
-
 
 /*
@@ -2690,9 +1249,104 @@
 };
 
+#if defined(PJ_WIN32) && PJ_WIN32!=0
+#include <windows.h>
+
+static pj_thread_desc handler_desc;
+
+static BOOL WINAPI CtrlHandler(DWORD fdwCtrlType)
+{   
+    switch (fdwCtrlType) 
+    { 
+        // Handle the CTRL+C signal. 
+ 
+        case CTRL_C_EVENT: 
+        case CTRL_CLOSE_EVENT: 
+        case CTRL_BREAK_EVENT: 
+        case CTRL_LOGOFF_EVENT: 
+        case CTRL_SHUTDOWN_EVENT: 
+	    pj_thread_register("ctrlhandler", handler_desc, &sig_thread);
+	    PJ_LOG(3,(THIS_FILE, "Ctrl-C detected, quitting.."));
+	    receive_end_sig = PJ_TRUE;
+            app_destroy();	    
+	    ExitProcess(1);
+            PJ_UNREACHED(return TRUE;)
+ 
+        default: 
+ 
+            return FALSE; 
+    } 
+}
+
+static void setup_socket_signal()
+{
+}
+
+#else
+#include <signal.h>
+
+static void setup_socket_signal()
+{
+    signal(SIGPIPE, SIG_IGN);
+}
+
+#endif
+
+static pj_status_t setup_pjsua()
+{
+    pj_status_t status = pjsua_destroy();
+    if (status != PJ_SUCCESS)
+	return status;
+
+    /* Create pjsua */
+    status = pjsua_create();
+    if (status != PJ_SUCCESS)
+	return status;
+
+    /* Create pool for application */
+    app_config.pool = pjsua_pool_create("pjsua-app", 1000, 1000);
+
+    return status;
+}
+
 /*****************************************************************************
  * Public API
  */
 
-pj_status_t app_init(int argc, char *argv[])
+#if defined(PJ_WIN32) && PJ_WIN32!=0
+PJ_DEF(void) setup_signal_handler(void)
+{
+    SetConsoleCtrlHandler(&CtrlHandler, TRUE);
+}
+#else
+PJ_DEF(void) setup_signal_handler(void)
+{
+}
+#endif
+
+int stdout_refresh_proc(void *arg)
+{
+    extern char *stdout_refresh_text;
+
+    PJ_UNUSED_ARG(arg);
+
+    /* Set thread to lowest priority so that it doesn't clobber
+     * stdout output
+     */
+    pj_thread_set_prio(pj_thread_this(), 
+		       pj_thread_get_prio_min(pj_thread_this()));
+
+    while (!stdout_refresh_quit) {
+	pj_thread_sleep(stdout_refresh * 1000);
+	puts(stdout_refresh_text);
+	fflush(stdout);
+    }
+
+    return 0;
+}
+
+PJ_DEF(pj_status_t) app_init(pj_cli_telnet_on_started on_started_cb,
+			     pj_cli_on_quit on_quit_cb,
+			     pj_cli_on_destroy on_destroy_cb,
+			     pj_cli_on_restart_pjsua on_restart_pjsua_cb)
 {
     pjsua_transport_id transport_id = -1;
@@ -2701,21 +1355,20 @@
     pj_status_t status;
 
-    app_restart = PJ_FALSE;
-
-    /* Create pjsua */
-    status = pjsua_create();
+    /** Setup pjsua **/
+    status = setup_pjsua();
     if (status != PJ_SUCCESS)
 	return status;
 
-    /* Create pool for application */
-    app_config.pool = pjsua_pool_create("pjsua-app", 1000, 1000);
-
-    /* Initialize default config */
-    default_config(&app_config);
-    
-    /* Parse the arguments */
-    status = parse_args(argc, argv, &app_config, &uri_arg);
+    /** Load config **/
+    status = load_config(&app_config, &uri_arg, app_running);
     if (status != PJ_SUCCESS)
-	return status;
+	return status;	    
+
+#if defined(PJ_SYMBIAN) && PJ_SYMBIAN!=0
+    /* Disable threading on Symbian */
+    app_config.cfg.thread_cnt = 0;
+    app_config.media_cfg.thread_cnt = 0;
+    app_config.media_cfg.has_ioqueue = PJ_FALSE;
+#endif
 
     /* Initialize application callbacks */
@@ -3237,14 +1890,20 @@
     }
 
+    /* Init call setting */
+    pjsua_call_setting_default(&call_opt);
+    call_opt.aud_cnt = app_config.aud_cnt;
+    call_opt.vid_cnt = app_config.vid.vid_cnt;    
+
+    /* Init CLI if configured */    
     if (app_config.use_cli) {
-	/*
-	 * Init CLI
-	 */    
-	status = setup_cli();
-	if (status != PJ_SUCCESS)
-	    goto on_error;
-	
-	PJ_LOG(3,(THIS_FILE, "CLI telnet daemon listening at port %d", 
-		  app_config.cli_telnet_port));
+	if (app_restart) {
+	    pj_uint16_t port = (pj_uint16_t)app_config.cli_telnet_port;
+	    status = setup_cli(!app_config.disable_cli_console, 
+			       app_config.cli_telnet_port >= 0, port,
+			       on_started_cb, on_quit_cb, on_destroy_cb,
+			       on_restart_pjsua_cb);
+	    if (status != PJ_SUCCESS)
+		goto on_error;
+	}
     }
 
@@ -3252,4 +1911,5 @@
 
 on_error:
+    app_restart = PJ_FALSE;
     app_destroy();
     return status;
@@ -3259,12 +1919,4 @@
 {
     pj_thread_t *stdout_refresh_thread = NULL;
-    pj_status_t status;
-
-    /* Start pjsua */
-    status = pjsua_start();
-    if (status != PJ_SUCCESS) {
-	app_destroy();
-	return status;
-    }
 
     /* Start console refresh thread */
@@ -3275,7 +1927,7 @@
 
     if (app_config.use_cli)
-	cli_console_app_main(&uri_arg, &app_restart);
-    else 
-	console_app_main(&uri_arg, &app_restart);
+	start_cli_main(&uri_arg, &app_restart);	
+    else
+	start_ui_main(&uri_arg, &app_restart);
 
     if (stdout_refresh_thread) {
@@ -3288,5 +1940,5 @@
 }
 
-pj_status_t app_destroy(void)
+pj_status_t app_destroy()
 {
     pj_status_t status;
@@ -3344,5 +1996,5 @@
 
     if (app_config.use_cli) {	
-	destroy_cli();
+	destroy_cli(app_restart);
     }
 
@@ -3351,12 +2003,72 @@
 	app_config.pool = NULL;
     }
-
+    
     status = pjsua_destroy();
-
-    pj_bzero(&app_config, sizeof(app_config));
-
+    
+    if (!app_restart)
+	pj_bzero(&app_config, sizeof(app_config));
+    
     return status;
 }
 
+/** === CLI Callback == **/
+
+static void cli_telnet_started(pj_cli_telnet_info *telnet_info)
+{    
+    PJ_LOG(3,(THIS_FILE, "Telnet daemon listening at %.*s:%d", 
+	      telnet_info->ip_address.slen, telnet_info->ip_address.ptr,
+	      telnet_info->port));
+}
+
+static void cli_on_quit (pj_bool_t is_restarted)
+{
+    PJ_LOG(3,(THIS_FILE, "CLI quit, restart(%d)", is_restarted));
+}
+
+static void cli_on_destroy(void)
+{
+    PJ_LOG(3,(THIS_FILE, "CLI destroyed"));
+}
+
+static void cli_on_restart_pjsua(void)
+{
+    PJ_LOG(3,(THIS_FILE, "Restart pjsua"));
+}
+
+/** ======================= **/
+
+int main_func(int argc, char *argv[])
+{
+    pj_status_t status;
+
+    setup_socket_signal();
+
+    receive_end_sig = PJ_FALSE;
+    app_restart = PJ_TRUE;
+
+    add_startup_config(argc, argv);    
+
+    do {
+	if (app_restart) {	    
+	    status = app_init(cli_telnet_started, cli_on_quit,
+			      cli_on_destroy, cli_on_restart_pjsua);
+	    if (status != PJ_SUCCESS)
+		return 1;	    
+	}	
+
+	app_running = PJ_TRUE;
+
+	app_main();
+	if (!receive_end_sig) {
+	    app_destroy();
+
+	    /* This is on purpose */
+	    app_destroy();
+	} else {
+	    pj_thread_join(sig_thread);
+	}
+    } while (app_restart);
+    return 0;
+}
 
 #ifdef STEREO_DEMO
@@ -3431,3 +2143,2 @@
 }
 #endif
-
Index: /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_cli.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_cli.c	(revision 4461)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_cli.c	(revision 4461)
@@ -0,0 +1,269 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+#include "pjsua_common.h"
+#include <pjlib-util/cli.h>
+#include <pjlib-util/cli_imp.h>
+#include <pjlib-util/cli_console.h>
+#include <pjlib-util/cli_telnet.h>
+#include <pjlib-util/scanner.h>
+
+#define THIS_FILE	"pjsua_cli.c"
+
+pj_cli_telnet_on_started   cli_telnet_on_started_cb = NULL;
+pj_cli_on_quit	   	   cli_on_quit_cb = NULL;
+pj_cli_on_destroy	   cli_on_destroy_cb = NULL;
+pj_cli_on_restart_pjsua	   cli_on_restart_pjsua_cb = NULL;
+
+pj_bool_t		   pjsua_restarted = PJ_TRUE;
+static pj_bool_t	   pj_inited = PJ_FALSE;
+static pj_caching_pool	   cli_cp;
+static pj_cli_t		   *cli = NULL;
+static pj_cli_sess	   *cli_cons_sess = NULL;
+
+/** Forward declaration **/
+pj_status_t setup_command(pj_cli_t *cli);
+
+static void log_writer(int level, const char *buffer, int len)
+{
+    if (cli)
+	pj_cli_write_log(cli, level, buffer, len);
+
+    if (app_config.disable_cli_console)
+	pj_log_write(level, buffer, len);
+}
+
+void destroy_cli(pj_bool_t app_restart)
+{    
+    pj_log_set_log_func(&pj_log_write);
+    
+    if (cli) {		
+	pj_cli_destroy(cli);
+	cli = NULL;
+    }
+
+    if (cli_cp.factory.create_pool) {
+	pj_caching_pool_destroy(&cli_cp);
+	pj_bzero(&cli_cp, sizeof(cli_cp));
+    }
+
+    if (pj_inited) {
+	pj_shutdown();
+	pj_inited = PJ_FALSE;
+    }
+    if (!app_restart) {
+	if (cli_on_destroy_cb)
+	    (*cli_on_destroy_cb)();
+    }
+}
+
+pj_status_t setup_cli(pj_bool_t with_console, pj_bool_t with_telnet,
+		      pj_uint16_t telnet_port, 
+		      pj_cli_telnet_on_started on_started_cb,
+		      pj_cli_on_quit on_quit_cb,
+		      pj_cli_on_destroy on_destroy_cb,
+		      pj_cli_on_restart_pjsua on_restart_pjsua_cb)
+{
+    pj_cli_cfg cli_cfg;
+    pj_status_t status;
+
+    /* Destroy CLI if initialized */
+    destroy_cli(PJ_TRUE);
+
+    /* Init PJLIB */
+    status = pj_init();
+    if (status != PJ_SUCCESS)
+	goto on_error;
+
+    pj_inited = PJ_TRUE;
+
+    /* Init PJLIB-UTIL */
+    status = pjlib_util_init();
+    if (status != PJ_SUCCESS)
+	goto on_error;
+
+    /* Init CLI */
+    pj_caching_pool_init(&cli_cp, NULL, 0);
+    pj_cli_cfg_default(&cli_cfg);
+    cli_cfg.pf = &cli_cp.factory;
+    cli_cfg.name = pj_str("pjsua_cli");
+    cli_cfg.title = pj_str("Pjsua CLI Application");
+    status = pj_cli_create(&cli_cfg, &cli);
+    if (status != PJ_SUCCESS)
+	goto on_error;
+
+    status = setup_command(cli);
+    if (status != PJ_SUCCESS)
+	goto on_error;
+
+    if (on_destroy_cb)
+	cli_on_destroy_cb = on_destroy_cb;
+
+    if (on_restart_pjsua_cb)
+	cli_on_restart_pjsua_cb = on_restart_pjsua_cb;
+
+    if (on_quit_cb)
+	cli_on_quit_cb = on_quit_cb;
+
+    /* Init telnet frontend */
+    if (with_telnet) {
+	pj_cli_telnet_cfg telnet_cfg;
+	pj_pool_t *pool;
+
+	pool = pj_pool_create(&cli_cp.factory, "cli_cp", 128, 128, NULL);
+	pj_assert(pool);
+
+	pj_cli_telnet_cfg_default(&telnet_cfg);
+	telnet_cfg.log_level = 5;
+	telnet_cfg.port = telnet_port;
+	if (on_started_cb)
+	    cli_telnet_on_started_cb = on_started_cb;
+
+	telnet_cfg.on_started = cli_telnet_on_started_cb;
+
+	status = pj_cli_telnet_create(cli, &telnet_cfg, NULL);
+	if (status != PJ_SUCCESS)
+	    goto on_error;
+    }
+
+    /* Init console frontend */
+    if (with_console) {
+	pj_cli_console_cfg console_cfg;
+	
+	pj_cli_console_cfg_default(&console_cfg);
+	console_cfg.quit_command = pj_str("shutdown");
+	status = pj_cli_console_create(cli, &console_cfg,
+				       &cli_cons_sess, NULL);
+	if (status != PJ_SUCCESS)
+	    goto on_error;
+    }
+
+    return PJ_SUCCESS;
+
+on_error:
+    destroy_cli(PJ_FALSE);
+    return status;
+}
+
+PJ_DEF(pj_bool_t) is_cli_inited()
+{
+    return (cli != NULL);
+}
+
+static pj_status_t setup_timer(pj_timer_heap_t **timer, 
+			       pj_ioqueue_t **ioqueue)
+{
+    pj_status_t status = pj_timer_heap_create(app_config.pool, 16, timer);
+
+    if (status != PJ_SUCCESS)
+	return status;
+
+    status = pj_ioqueue_create(app_config.pool, 16, ioqueue);    
+
+    return status;
+}
+
+static pj_status_t stop_timer(pj_timer_heap_t *timer, 
+			      pj_ioqueue_t *ioqueue)
+{
+    if ((!timer) || (!ioqueue))
+	return PJ_SUCCESS;
+
+    pj_timer_heap_destroy(timer);
+
+    return pj_ioqueue_destroy(ioqueue);
+}
+
+pj_status_t cli_pjsua_start(pj_str_t *uri_to_call, 
+			    pj_timer_heap_t **main_timer_heap, 
+			    pj_ioqueue_t **main_ioqueue)
+{
+    pj_status_t status = PJ_SUCCESS;
+
+    pjsua_restarted = PJ_FALSE;
+
+    if (app_config.disable_cli_console) {
+	status = setup_timer(main_timer_heap, main_ioqueue);
+	if (status != PJ_SUCCESS)
+	    return status;
+    }
+
+    status = pjsua_start();
+    if (status != PJ_SUCCESS)
+	return status;
+
+    pj_log_set_log_func(&log_writer);
+
+    setup_signal_handler();
+
+    /* If user specifies URI to call, then call the URI */
+    if (uri_to_call->slen) {
+	pjsua_call_make_call(current_acc, uri_to_call, &call_opt, NULL, 
+			     NULL, NULL);
+    }
+
+    if (!app_config.disable_cli_console)
+	PJ_LOG(3,(THIS_FILE, "CLI console is ready, press '?' for help"));
+
+    return status;
+}
+
+void start_cli_main(pj_str_t *uri_to_call, pj_bool_t *app_restart)
+{    
+    pj_status_t status;
+    char cmdline[PJ_CLI_MAX_CMDBUF];
+    pj_timer_heap_t *main_timer_heap = NULL;
+    pj_ioqueue_t *main_ioqueue = NULL;    
+
+    *app_restart = PJ_FALSE;
+    pjsua_restarted = PJ_TRUE;
+
+    do {
+	if (pjsua_restarted) {
+	    status = cli_pjsua_start(uri_to_call, &main_timer_heap, 
+				     &main_ioqueue);
+
+	    if (status != PJ_SUCCESS)
+		return;
+	}
+
+	if (app_config.disable_cli_console) {
+	    pj_time_val delay = {0, 10};
+	    pj_ioqueue_poll(main_ioqueue, &delay);
+	    if (pj_cli_is_quitting(cli))
+		continue;
+	    pj_timer_heap_poll(main_timer_heap, NULL);     
+	} else {
+	    pj_cli_console_process(cli_cons_sess, &cmdline[0], sizeof(cmdline));
+	}
+	if (pjsua_restarted) {
+	    status = stop_timer(main_timer_heap, main_ioqueue);
+	    if (status != PJ_SUCCESS)
+		return;
+	    
+	    status = app_init(NULL, NULL, NULL, NULL);
+	    if (status != PJ_SUCCESS)
+		return;
+	}
+
+    } while (!pj_cli_is_quitting(cli));
+    stop_timer(main_timer_heap, main_ioqueue);
+    *app_restart = pj_cli_is_restarting(cli);
+}
Index: /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_cli_cmd.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_cli_cmd.c	(revision 4460)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_cli_cmd.c	(revision 4461)
@@ -19,11 +19,15 @@
  */
 
-#include "pjsua_cmd.h"
+#include "pjsua_common.h"
 #include <pjlib-util/cli.h>
 #include <pjlib-util/cli_imp.h>
 #include <pjlib-util/cli_console.h>
 #include <pjlib-util/cli_telnet.h>
+#include <pjlib-util/scanner.h>
 
 #define THIS_FILE	"pjsua_cli_cmd.c"
+
+#define CHECK_PJSUA_RUNNING() if (pjsua_get_state()!=PJSUA_STATE_RUNNING) \
+				  return PJ_EINVALIDOP
 
 /* CLI command id */
@@ -39,4 +43,6 @@
 #define CMD_NETWORK		    900
 #define CMD_QUIT		    110
+#define CMD_RESTART		    120
+#define CMD_RELOAD		    130
 
 /* call level 2 command */
@@ -144,15 +150,9 @@
 #define DYN_CHOICE_ADDED_BUDDY_ID   (DYN_CHOICE_START)+12
 
-static pj_cli_cfg cli_cfg;
-static pj_cli_telnet_cfg telnet_cfg;
-static pj_cli_t *cli = NULL;
-static pj_cli_sess *sess = NULL;
-static pj_cli_console_cfg console_cfg;
-
 /* Get input URL */
 static void get_input_url(char *buf, 
 			  int len,
 			  pj_cli_cmd_val *cval,
-struct input_result *result)
+			  struct input_result *result)
 {
     static const pj_str_t err_invalid_input = {"Invalid input\n", 15};
@@ -203,5 +203,5 @@
 
 	pj_cli_sess_write_msg(cval->sess, err_invalid_input.ptr, 
-	    err_invalid_input.slen);
+			      err_invalid_input.slen);
 	result->nb_result = NO_NB;
 	return;
@@ -616,37 +616,6 @@
     default:
 	param->cnt = 0;
-    }
-}
-
-void cli_console_app_main(const pj_str_t *uri_to_call, pj_bool_t *app_restart)
-{        
-    pjsua_call_setting_default(&call_opt);
-    call_opt.aud_cnt = app_config.aud_cnt;
-    call_opt.vid_cnt = app_config.vid.vid_cnt;    
-
-    /* If user specifies URI to call, then call the URI */
-    if (uri_to_call->slen) {
-	pjsua_call_make_call(current_acc, uri_to_call, &call_opt, NULL, 
-			     NULL, NULL);
-    }
-
-    /*
-     * Main loop.
-     */
-    for (;;) {
-	char cmdline[PJ_CLI_MAX_CMDBUF];	
-        pj_status_t status;
-
-        status = pj_cli_console_process(sess, &cmdline[0], sizeof(cmdline));
-
-	if (status == PJ_CLI_EEXIT) {
-	    /* exit is called */
-	    break;
-	} else if (status != PJ_SUCCESS) {
-	    /* Something wrong with the cmdline */
-	    PJ_PERROR(1,(THIS_FILE, status, "Exec error"));
-	}
-    }    
-    *app_restart = pj_cli_is_restarting(cli);  
+	break;
+    }
 }
 
@@ -795,4 +764,6 @@
 {    
     pj_status_t status = PJ_SUCCESS;
+
+    CHECK_PJSUA_RUNNING();
 
     switch(pj_cli_get_cmd_id(cval->cmd)) {
@@ -1065,4 +1036,6 @@
     pj_status_t status = PJ_SUCCESS;
 
+    CHECK_PJSUA_RUNNING();
+
     switch(pj_cli_get_cmd_id(cval->cmd)) {
     case CMD_PRESENCE_ADD_BUDDY:
@@ -1107,6 +1080,6 @@
 
     for (i=0; i<count; ++i) {
-	char out_str[PJSUA_MAX_CALLS*6];
-	char txlist[PJSUA_MAX_CALLS*4+10];
+	char out_str[128];
+	char txlist[16];
 	unsigned j;
 	pjsua_conf_port_info info;
@@ -1224,4 +1197,6 @@
     pj_status_t status = PJ_SUCCESS;
 
+    CHECK_PJSUA_RUNNING();
+
     switch(pj_cli_get_cmd_id(cval->cmd)) {
     case CMD_MEDIA_LIST:
@@ -1306,4 +1281,6 @@
 {
     pj_status_t status = PJ_SUCCESS;
+
+    CHECK_PJSUA_RUNNING();
 
     switch(pj_cli_get_cmd_id(cval->cmd)) {
@@ -1524,5 +1501,4 @@
 {
     if (current_call != PJSUA_INVALID_ID) {
-	call_opt.flag |= PJSUA_CALL_UNHOLD;
 	pjsua_call_update2(current_call, &call_opt, NULL);
     } else {
@@ -1923,4 +1899,6 @@
     pj_cli_cmd_id cmd_id = pj_cli_get_cmd_id(cval->cmd);
 
+    CHECK_PJSUA_RUNNING();
+
     switch(cmd_id) {
     case CMD_CALL_NEW:
@@ -2012,4 +1990,6 @@
     pjsua_acc_config acc_cfg;
     pj_cli_cmd_id cmd_id = pj_cli_get_cmd_id(cval->cmd);
+
+    CHECK_PJSUA_RUNNING();
 
     pjsua_acc_get_config(current_acc, &acc_cfg);
@@ -2322,4 +2302,6 @@
     pj_cli_cmd_id cmd_id = pj_cli_get_cmd_id(cval->cmd);    
 
+    CHECK_PJSUA_RUNNING();
+
     switch(cmd_id) {
     case CMD_VIDEO_ENABLE:
@@ -2415,5 +2397,8 @@
 {
     pj_status_t status = PJ_SUCCESS;
-    PJ_UNUSED_ARG(cval);    
+    PJ_UNUSED_ARG(cval);
+
+    CHECK_PJSUA_RUNNING();
+    
     status = pjsua_detect_nat_type();
     if (status != PJ_SUCCESS)
@@ -2425,6 +2410,11 @@
 static pj_status_t cmd_quit_handler(pj_cli_cmd_val *cval)
 {
+    extern pj_cli_on_quit cli_on_quit_cb;
     PJ_LOG(3,(THIS_FILE, "Quitting app.."));
-    pj_cli_quit(cval->sess->fe->cli, cval->sess, PJ_FALSE);    
+    pj_cli_quit(cval->sess->fe->cli, cval->sess, PJ_FALSE);
+    /** Call pj_cli_on_quit callback **/
+    if (cli_on_quit_cb)
+	(*cli_on_quit_cb)(PJ_FALSE);
+
     return PJ_SUCCESS;
 }
@@ -2432,6 +2422,69 @@
 static pj_status_t cmd_restart_handler(pj_cli_cmd_val *cval)
 {
+    extern pj_cli_on_quit cli_on_quit_cb;
     PJ_LOG(3,(THIS_FILE, "Restarting app.."));
-    pj_cli_quit(cval->sess->fe->cli, cval->sess, PJ_TRUE);    
+    pj_cli_quit(cval->sess->fe->cli, cval->sess, PJ_TRUE);
+    /** Call pj_cli_on_quit callback **/
+    if (cli_on_quit_cb)
+	(*cli_on_quit_cb)(PJ_TRUE);
+
+    return PJ_SUCCESS;
+}
+
+/* 
+ * Syntax error handler for parser. 
+ */
+static void on_syntax_error(pj_scanner *scanner)
+{
+    PJ_UNUSED_ARG(scanner);
+    PJ_THROW(PJ_EINVAL);
+}
+
+static pj_status_t get_options(pj_str_t *options, unsigned *cmd_count)
+{
+    pj_scanner scanner;
+    pj_str_t str;
+    
+    PJ_USE_EXCEPTION;
+
+    if (!options)
+	return PJ_SUCCESS;
+
+    pj_scan_init(&scanner, options->ptr, options->slen, PJ_SCAN_AUTOSKIP_WS, 
+		 &on_syntax_error);
+    PJ_TRY {
+	while (!pj_scan_is_eof(&scanner)) {	    
+	    ++(*cmd_count);
+	    pj_scan_get_until_chr(&scanner, " \t\r\n", &str);
+	    /** Store to command arguments **/	    
+	    add_reload_config(*cmd_count, &str);	    
+	}
+    }
+    PJ_CATCH_ANY {
+	pj_scan_fini(&scanner);	
+	return PJ_GET_EXCEPTION();
+    }
+    PJ_END;
+    return PJ_SUCCESS;
+}
+
+static pj_status_t cmd_reload_handler(pj_cli_cmd_val *cval)
+{
+    int i;
+    unsigned cmd_count = 0;
+    extern pj_bool_t pjsua_restarted;
+    extern pj_cli_on_restart_pjsua cli_on_restart_pjsua_cb;
+
+    PJ_LOG(3,(THIS_FILE, "Reloading Pjsua.."));
+    /** Get the pjsua option **/       
+    
+    for (i=1;i<cval->argc;i++) {
+	get_options(&cval->argv[i], &cmd_count);
+    }
+    pjsua_restarted = PJ_TRUE;
+
+    if (cli_on_restart_pjsua_cb)
+	(*cli_on_restart_pjsua_cb)();
+
     return PJ_SUCCESS;
 }
@@ -2832,4 +2885,12 @@
 	"<CMD name='restart' id='120' desc='Restart application'/>";
 
+    char* reload_command =
+	"<CMD name='reload' id='130' desc='Reload pjsua'>"
+	"  <ARG name='options1' type='string' desc='Options' optional='1'/>"
+	"  <ARG name='options2' type='string' desc='Options' optional='1'/>"
+	"  <ARG name='options3' type='string' desc='Options' optional='1'/>"
+	"  <ARG name='options4' type='string' desc='Options' optional='1'/>"
+	"</CMD>";
+
     pj_status_t status;
     pj_str_t sleep_xml = pj_str(sleep_command);    
@@ -2837,4 +2898,5 @@
     pj_str_t shutdown_xml = pj_str(shutdown_command);
     pj_str_t restart_xml = pj_str(restart_command);
+    pj_str_t reload_xml = pj_str(reload_command);
 
     status = pj_cli_add_cmd_from_xml(cli, NULL, 
@@ -2860,9 +2922,15 @@
 				     &restart_xml, cmd_restart_handler, 
 				     NULL, NULL);
+    if (status != PJ_SUCCESS)
+	return status;
+
+    status = pj_cli_add_cmd_from_xml(cli, NULL, 
+				     &reload_xml, cmd_reload_handler, 
+				     NULL, NULL);
 
     return status;
 }
 
-static pj_status_t setup_command()
+pj_status_t setup_command(pj_cli_t *cli)
 {
     pj_status_t status;
@@ -2898,57 +2966,2 @@
     return status;
 }
-
-static void log_writer(int level, const char *buffer, int len)
-{
-    if (cli)
-	pj_cli_write_log(cli, level, buffer, len);
-}
-
-pj_status_t setup_cli()
-{
-    pj_status_t status;    
-    pj_cli_cfg_default(&cli_cfg);
-    cli_cfg.pf = app_config.pool->factory;    
-    cli_cfg.name = pj_str("pjsua_cli");
-    cli_cfg.title = pj_str("Pjsua CLI Application");
-
-    status = pj_cli_create(&cli_cfg, &cli);
-    if (status != PJ_SUCCESS)
-	return status;
-
-    status = setup_command();
-    if (status != PJ_SUCCESS)
-	return status;
-
-    pj_log_set_log_func(&log_writer);
-
-    /* 
-    * Init telnet
-    */ 
-    pj_cli_telnet_cfg_default(&telnet_cfg);
-    telnet_cfg.log_level = 5;
-    if (app_config.cli_telnet_port)
-	telnet_cfg.port = (pj_uint16_t)app_config.cli_telnet_port;
-
-    status = pj_cli_telnet_create(cli, &telnet_cfg, NULL);
-    if (status != PJ_SUCCESS)
-	return status;
-
-    app_config.cli_telnet_port = telnet_cfg.port;;
-
-    /*
-    * Init console
-    */ 
-    pj_cli_console_cfg_default(&console_cfg);
-    console_cfg.quit_command = pj_str("shutdown");
-    status = pj_cli_console_create(cli, &console_cfg, &sess, NULL);
-    return status;
-}
-
-void destroy_cli()
-{
-    pj_log_set_log_func(&pj_log_write);    
-    pj_cli_destroy(cli);
-    cli = NULL;  
-}
-
